<!DOCTYPE html>
<html>
<head>
  <title>Artillery report</title>
  <script src='https://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js'></script>
  <script src='https://cdnjs.cloudflare.com/ajax/libs/d3/3.5.0/d3.min.js' charset='utf-8'></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/metrics-graphics/2.6.0/metricsgraphics.min.css" />
  <script src="https://cdnjs.cloudflare.com/ajax/libs/metrics-graphics/2.6.0/metricsgraphics.min.js"></script>

  <link href='https://fonts.googleapis.com/css?family=Open+Sans:400,300,700' rel='stylesheet' type='text/css'>
  <link href='https://fonts.googleapis.com/css?family=PT+Serif:400,700,400italic' rel='stylesheet' type='text/css'>
  <link href='https://netdna.bootstrapcdn.com/font-awesome/4.2.0/css/font-awesome.css' rel='stylesheet' type='text/css'>
  <link href='https://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/css/bootstrap.min.css' rel='stylesheet' type='text/css'>

  <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.10.6/moment.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/lodash.js/3.10.1/lodash.min.js"></script>

  <script src="https://cdnjs.cloudflare.com/ajax/libs/ace/1.2.0/ace.js" charset="utf-8"></script>

  <style>
  body, p, li {
    font-family: sans-serif;
    font-size: 10pt;
  }

  h1 {
    font-size: 18pt;
    font-weight: bold;
  }

  #errorsContainer > p {
    color: #009900;
  }

  #footer {
    padding: 1em;
    font-size: 0.8em;
    color: #999;
    text-align: center;
    margin-top: 1em;
    background-color: #eee;
  }
  #editor {
    font-size: 8pt;
    height: 20em;
  }
  </style>

  <script>
  window.Report = {
  "aggregate": {
    "timestamp": "2019-04-10T21:08:01.254Z",
    "scenariosCreated": 7795,
    "scenariosCompleted": 7795,
    "requestsCompleted": 7795,
    "latency": {
      "min": 2.5,
      "max": 1021.1,
      "median": 5.6,
      "p95": 19.9,
      "p99": 595.1
    },
    "rps": {
      "count": 7795,
      "mean": 18.52
    },
    "scenarioDuration": {
      "min": 4.2,
      "max": 1026.2,
      "median": 8.3,
      "p95": 23.5,
      "p99": 601.8
    },
    "scenarioCounts": {
      "0": 7795
    },
    "errors": {},
    "codes": {
      "200": 7795
    },
    "matches": 0,
    "customStats": {},
    "counters": {},
    "scenariosAvoided": 0,
    "phases": [
      {
        "duration": 120,
        "arrivalRate": 10,
        "rampTo": 20,
        "name": "Warm up the application"
      },
      {
        "duration": 300,
        "arrivalRate": 20,
        "name": "Sustained max load"
      }
    ]
  },
  "intermediate": [
    {
      "timestamp": "2019-04-10T21:01:10.171Z",
      "scenariosCreated": 101,
      "scenariosCompleted": 101,
      "requestsCompleted": 101,
      "latency": {
        "min": 3.2,
        "max": 560.8,
        "median": 4.9,
        "p95": 260.5,
        "p99": 529.9
      },
      "rps": {
        "count": 101,
        "mean": 10.25
      },
      "scenarioDuration": {
        "min": 5.2,
        "max": 602.1,
        "median": 7.6,
        "p95": 263.4,
        "p99": 582.9
      },
      "scenarioCounts": {
        "0": 101
      },
      "errors": {},
      "codes": {
        "200": 101
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:01:20.169Z",
      "scenariosCreated": 106,
      "scenariosCompleted": 106,
      "requestsCompleted": 106,
      "latency": {
        "min": 3.2,
        "max": 42.2,
        "median": 5.3,
        "p95": 15.2,
        "p99": 39.8
      },
      "rps": {
        "count": 106,
        "mean": 10.65
      },
      "scenarioDuration": {
        "min": 5.4,
        "max": 44.2,
        "median": 8.9,
        "p95": 18.7,
        "p99": 42.8
      },
      "scenarioCounts": {
        "0": 106
      },
      "errors": {},
      "codes": {
        "200": 106
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:01:30.171Z",
      "scenariosCreated": 136,
      "scenariosCompleted": 136,
      "requestsCompleted": 136,
      "latency": {
        "min": 3.3,
        "max": 1018.9,
        "median": 6.1,
        "p95": 700.3,
        "p99": 974.4
      },
      "rps": {
        "count": 136,
        "mean": 13.67
      },
      "scenarioDuration": {
        "min": 5.3,
        "max": 1021,
        "median": 9.5,
        "p95": 703.1,
        "p99": 977.6
      },
      "scenarioCounts": {
        "0": 136
      },
      "errors": {},
      "codes": {
        "200": 136
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:01:40.172Z",
      "scenariosCreated": 128,
      "scenariosCompleted": 128,
      "requestsCompleted": 128,
      "latency": {
        "min": 3.2,
        "max": 30.6,
        "median": 5.2,
        "p95": 16.6,
        "p99": 24.3
      },
      "rps": {
        "count": 128,
        "mean": 12.81
      },
      "scenarioDuration": {
        "min": 5.3,
        "max": 33.7,
        "median": 8.5,
        "p95": 21.6,
        "p99": 27.5
      },
      "scenarioCounts": {
        "0": 128
      },
      "errors": {},
      "codes": {
        "200": 128
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:01:50.172Z",
      "scenariosCreated": 129,
      "scenariosCompleted": 129,
      "requestsCompleted": 129,
      "latency": {
        "min": 3.3,
        "max": 24.4,
        "median": 4.8,
        "p95": 11.7,
        "p99": 24
      },
      "rps": {
        "count": 129,
        "mean": 12.91
      },
      "scenarioDuration": {
        "min": 5.1,
        "max": 27.2,
        "median": 8,
        "p95": 15,
        "p99": 27
      },
      "scenarioCounts": {
        "0": 129
      },
      "errors": {},
      "codes": {
        "200": 129
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:02:00.174Z",
      "scenariosCreated": 130,
      "scenariosCompleted": 130,
      "requestsCompleted": 130,
      "latency": {
        "min": 3.4,
        "max": 27.6,
        "median": 5.1,
        "p95": 12.8,
        "p99": 22.4
      },
      "rps": {
        "count": 130,
        "mean": 13.03
      },
      "scenarioDuration": {
        "min": 5.6,
        "max": 30.1,
        "median": 8.3,
        "p95": 20.3,
        "p99": 26
      },
      "scenarioCounts": {
        "0": 130
      },
      "errors": {},
      "codes": {
        "200": 130
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:02:10.172Z",
      "scenariosCreated": 160,
      "scenariosCompleted": 160,
      "requestsCompleted": 160,
      "latency": {
        "min": 2.9,
        "max": 58.4,
        "median": 5.2,
        "p95": 11,
        "p99": 30.2
      },
      "rps": {
        "count": 160,
        "mean": 16.08
      },
      "scenarioDuration": {
        "min": 5.3,
        "max": 60.7,
        "median": 8.1,
        "p95": 15.4,
        "p99": 33.6
      },
      "scenarioCounts": {
        "0": 160
      },
      "errors": {},
      "codes": {
        "200": 160
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:02:20.178Z",
      "scenariosCreated": 164,
      "scenariosCompleted": 164,
      "requestsCompleted": 164,
      "latency": {
        "min": 3.6,
        "max": 47.3,
        "median": 5.4,
        "p95": 14.9,
        "p99": 33.9
      },
      "rps": {
        "count": 164,
        "mean": 16.4
      },
      "scenarioDuration": {
        "min": 5.8,
        "max": 50.5,
        "median": 8.7,
        "p95": 18.4,
        "p99": 37.3
      },
      "scenarioCounts": {
        "0": 164
      },
      "errors": {},
      "codes": {
        "200": 164
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:02:30.172Z",
      "scenariosCreated": 169,
      "scenariosCompleted": 169,
      "requestsCompleted": 169,
      "latency": {
        "min": 3.2,
        "max": 145.1,
        "median": 5.1,
        "p95": 31.1,
        "p99": 118.2
      },
      "rps": {
        "count": 169,
        "mean": 16.98
      },
      "scenarioDuration": {
        "min": 5,
        "max": 149.2,
        "median": 8,
        "p95": 34.9,
        "p99": 122.1
      },
      "scenarioCounts": {
        "0": 169
      },
      "errors": {},
      "codes": {
        "200": 169
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:02:40.170Z",
      "scenariosCreated": 177,
      "scenariosCompleted": 177,
      "requestsCompleted": 177,
      "latency": {
        "min": 3.1,
        "max": 51.5,
        "median": 5,
        "p95": 10.8,
        "p99": 18.1
      },
      "rps": {
        "count": 177,
        "mean": 17.72
      },
      "scenarioDuration": {
        "min": 4.9,
        "max": 55.2,
        "median": 7.9,
        "p95": 14.2,
        "p99": 28.3
      },
      "scenarioCounts": {
        "0": 177
      },
      "errors": {},
      "codes": {
        "200": 177
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:02:50.171Z",
      "scenariosCreated": 186,
      "scenariosCompleted": 186,
      "requestsCompleted": 186,
      "latency": {
        "min": 3.1,
        "max": 42.2,
        "median": 5.3,
        "p95": 13.6,
        "p99": 29.8
      },
      "rps": {
        "count": 186,
        "mean": 18.6
      },
      "scenarioDuration": {
        "min": 4.9,
        "max": 45,
        "median": 8,
        "p95": 16.8,
        "p99": 32.8
      },
      "scenarioCounts": {
        "0": 186
      },
      "errors": {},
      "codes": {
        "200": 186
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:03:00.171Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3.5,
        "max": 111.1,
        "median": 5.8,
        "p95": 14.2,
        "p99": 39.2
      },
      "rps": {
        "count": 200,
        "mean": 20.02
      },
      "scenarioDuration": {
        "min": 5.6,
        "max": 114.5,
        "median": 8.9,
        "p95": 17.9,
        "p99": 44.1
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:03:10.172Z",
      "scenariosCreated": 199,
      "scenariosCompleted": 199,
      "requestsCompleted": 199,
      "latency": {
        "min": 3.5,
        "max": 77,
        "median": 6.4,
        "p95": 14.8,
        "p99": 47.3
      },
      "rps": {
        "count": 199,
        "mean": 19.9
      },
      "scenarioDuration": {
        "min": 5.7,
        "max": 87.5,
        "median": 9.8,
        "p95": 22.8,
        "p99": 58.1
      },
      "scenarioCounts": {
        "0": 199
      },
      "errors": {},
      "codes": {
        "200": 199
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:03:20.169Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3.4,
        "max": 98.5,
        "median": 6.9,
        "p95": 20.4,
        "p99": 50.6
      },
      "rps": {
        "count": 200,
        "mean": 20.02
      },
      "scenarioDuration": {
        "min": 4.7,
        "max": 108.1,
        "median": 10.8,
        "p95": 28.9,
        "p99": 84.6
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:03:30.170Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3.2,
        "max": 27.7,
        "median": 6.4,
        "p95": 14.5,
        "p99": 26.7
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 4.6,
        "max": 44.5,
        "median": 9,
        "p95": 17.4,
        "p99": 32.5
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:03:40.169Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 2.9,
        "max": 35.3,
        "median": 4.8,
        "p95": 10.9,
        "p99": 25.8
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 4.2,
        "max": 38.1,
        "median": 7.2,
        "p95": 14.5,
        "p99": 28.4
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:03:50.168Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3.2,
        "max": 76.5,
        "median": 4.8,
        "p95": 13.2,
        "p99": 28.6
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 4.5,
        "max": 79.5,
        "median": 7.1,
        "p95": 15.4,
        "p99": 32.4
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:04:00.168Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3,
        "max": 33.2,
        "median": 5.1,
        "p95": 13.2,
        "p99": 24.3
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 4.5,
        "max": 39.7,
        "median": 7.5,
        "p95": 16.2,
        "p99": 26.8
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:04:10.168Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3,
        "max": 33.7,
        "median": 4.2,
        "p95": 11.4,
        "p99": 31.7
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 4.3,
        "max": 36.8,
        "median": 6.3,
        "p95": 13.8,
        "p99": 33.8
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:04:20.167Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3.2,
        "max": 26.2,
        "median": 5,
        "p95": 12.9,
        "p99": 22
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 4.6,
        "max": 28.8,
        "median": 7.4,
        "p95": 16.6,
        "p99": 24.9
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:04:30.167Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3,
        "max": 17.7,
        "median": 4.3,
        "p95": 12.7,
        "p99": 17.6
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 4.2,
        "max": 20.7,
        "median": 6.5,
        "p95": 15.5,
        "p99": 19.4
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:04:40.171Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 2.5,
        "max": 36.4,
        "median": 4.9,
        "p95": 9.8,
        "p99": 15.7
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 4.9,
        "max": 39.6,
        "median": 7.4,
        "p95": 12.9,
        "p99": 19
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:04:50.167Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3,
        "max": 20.7,
        "median": 5,
        "p95": 11.2,
        "p99": 17.4
      },
      "rps": {
        "count": 200,
        "mean": 20.02
      },
      "scenarioDuration": {
        "min": 4.5,
        "max": 22.7,
        "median": 7.7,
        "p95": 14.5,
        "p99": 20.7
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:05:00.166Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3.4,
        "max": 45.7,
        "median": 5.2,
        "p95": 11.5,
        "p99": 14.8
      },
      "rps": {
        "count": 200,
        "mean": 20.02
      },
      "scenarioDuration": {
        "min": 5,
        "max": 48.1,
        "median": 7.7,
        "p95": 15.2,
        "p99": 20
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:05:10.167Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3,
        "max": 25.9,
        "median": 5.2,
        "p95": 14,
        "p99": 19.5
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 4.5,
        "max": 59.5,
        "median": 7.5,
        "p95": 17.6,
        "p99": 29.4
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:05:20.165Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3.1,
        "max": 41.8,
        "median": 5.1,
        "p95": 10,
        "p99": 17.8
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 4.5,
        "max": 50.2,
        "median": 7.3,
        "p95": 12.2,
        "p99": 23
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:05:30.165Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 2.8,
        "max": 41.6,
        "median": 5.8,
        "p95": 21.4,
        "p99": 37.9
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 4.3,
        "max": 44,
        "median": 8.4,
        "p95": 23.7,
        "p99": 40.4
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:05:40.170Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3.3,
        "max": 32.9,
        "median": 5.8,
        "p95": 16.6,
        "p99": 27.2
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 5.3,
        "max": 34.9,
        "median": 8.7,
        "p95": 19.2,
        "p99": 30
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:05:50.164Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 198,
      "requestsCompleted": 198,
      "latency": {
        "min": 3.7,
        "max": 987.4,
        "median": 6.1,
        "p95": 515.4,
        "p99": 912.7
      },
      "rps": {
        "count": 200,
        "mean": 20.02
      },
      "scenarioDuration": {
        "min": 5.2,
        "max": 988.9,
        "median": 8.7,
        "p95": 517,
        "p99": 914.9
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 198
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 2,
      "pendingRequests": 2,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:06:00.167Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 201,
      "requestsCompleted": 201,
      "latency": {
        "min": 3.4,
        "max": 1010.1,
        "median": 7.5,
        "p95": 778.5,
        "p99": 973.7
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 5.2,
        "max": 1011.8,
        "median": 9.8,
        "p95": 780.1,
        "p99": 975.8
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 201
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 1,
      "pendingRequests": 1,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:06:10.164Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 201,
      "requestsCompleted": 201,
      "latency": {
        "min": 3.3,
        "max": 1021.1,
        "median": 6.3,
        "p95": 786.7,
        "p99": 987.6
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 5.3,
        "max": 1026.2,
        "median": 9,
        "p95": 788.7,
        "p99": 989.9
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 201
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:06:20.164Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3.5,
        "max": 63.9,
        "median": 5.9,
        "p95": 17,
        "p99": 32.9
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 4.9,
        "max": 66.7,
        "median": 8.8,
        "p95": 19.9,
        "p99": 35.6
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:06:30.164Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3.3,
        "max": 51.8,
        "median": 5.4,
        "p95": 15.4,
        "p99": 24.9
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 4.8,
        "max": 55.6,
        "median": 8.1,
        "p95": 17.8,
        "p99": 27.8
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:06:40.164Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 2.9,
        "max": 37,
        "median": 5.6,
        "p95": 18.7,
        "p99": 32.4
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 4.3,
        "max": 44.3,
        "median": 8.4,
        "p95": 20.8,
        "p99": 35.2
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:06:50.164Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3.4,
        "max": 40.7,
        "median": 5.4,
        "p95": 19.1,
        "p99": 32.2
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 5.5,
        "max": 45,
        "median": 8.3,
        "p95": 22,
        "p99": 35.9
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:07:00.163Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3.6,
        "max": 25.1,
        "median": 5.7,
        "p95": 14,
        "p99": 23.6
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 5,
        "max": 36.6,
        "median": 8.6,
        "p95": 19.3,
        "p99": 27.5
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:07:10.163Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3.2,
        "max": 1002.8,
        "median": 7.4,
        "p95": 567.4,
        "p99": 930.8
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 5.3,
        "max": 1005.4,
        "median": 10,
        "p95": 569.1,
        "p99": 932.2
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:07:20.162Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3.7,
        "max": 29.7,
        "median": 6.9,
        "p95": 19,
        "p99": 24.4
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 5.1,
        "max": 32,
        "median": 9.7,
        "p95": 21.3,
        "p99": 27.4
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:07:30.163Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3.7,
        "max": 990.1,
        "median": 6.9,
        "p95": 528.7,
        "p99": 919.7
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 5.2,
        "max": 991.9,
        "median": 9.7,
        "p95": 530.7,
        "p99": 921.4
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:07:40.162Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3.3,
        "max": 974,
        "median": 6.7,
        "p95": 503.3,
        "p99": 900.2
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 5.1,
        "max": 975.3,
        "median": 9.3,
        "p95": 505.7,
        "p99": 902
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:07:50.163Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 4,
        "max": 40.4,
        "median": 6.2,
        "p95": 18,
        "p99": 38.6
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 5.9,
        "max": 42.9,
        "median": 9,
        "p95": 20.7,
        "p99": 42
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:08:00.162Z",
      "scenariosCreated": 200,
      "scenariosCompleted": 200,
      "requestsCompleted": 200,
      "latency": {
        "min": 3.2,
        "max": 33.3,
        "median": 5.7,
        "p95": 16.9,
        "p99": 25.1
      },
      "rps": {
        "count": 200,
        "mean": 20
      },
      "scenarioDuration": {
        "min": 4.5,
        "max": 36.1,
        "median": 8.3,
        "p95": 19.7,
        "p99": 27.6
      },
      "scenarioCounts": {
        "0": 200
      },
      "errors": {},
      "codes": {
        "200": 200
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    },
    {
      "timestamp": "2019-04-10T21:08:01.118Z",
      "scenariosCreated": 10,
      "scenariosCompleted": 10,
      "requestsCompleted": 10,
      "latency": {
        "min": 4.6,
        "max": 15.5,
        "median": 6,
        "p95": 15.5,
        "p99": 15.5
      },
      "rps": {
        "count": 10,
        "mean": 10.53
      },
      "scenarioDuration": {
        "min": 7.1,
        "max": 18.4,
        "median": 10.9,
        "p95": 18.4,
        "p99": 18.4
      },
      "scenarioCounts": {
        "0": 10
      },
      "errors": {},
      "codes": {
        "200": 10
      },
      "matches": 0,
      "customStats": {},
      "counters": {},
      "concurrency": 0,
      "pendingRequests": 0,
      "scenariosAvoided": 0
    }
  ]
};
  </script>

  <style>
      h1 {
        line-height: 200%;
      }

      body {
          background-color: #fcfcfc;
      }

      .container {
          width: 100%;
          min-width: 960px;
      }
  </style>


</head>
<body>

<div class="container">

<div class="row" id="header">
  <div class="col-lg-4 col-lg-offset-4">
    <pre style="font-size: 5pt; background-color: #fcfcfc; border: none;">
            _   _ _ _                                                _
  __ _ _ __| |_(_) | | ___ _ __ _   _      _ __ ___ _ __   ___  _ __| |_
 / _` | '__| __| | | |/ _ \ '__| | | |    | '__/ _ \ '_ \ / _ \| '__| __|
| (_| | |  | |_| | | |  __/ |  | |_| |    | | |  __/ |_) | (_) | |  | |_
 \__,_|_|   \__|_|_|_|\___|_|   \__, |    |_|  \___| .__/ \___/|_|   \__|
                                |___/              |_|

    </pre>
  </div>
</div>

<div class="row">
  <div class="col-lg-12">
    <h1 class="text-center" id="page-title">Test run on <span id="timestamp">date</span></h1>
  </div>
</div>

<div class="row">
  <div class="col-lg-3">
    <p><strong>Summary</strong></p>
    <table class="table table-bordered table-hover table-condensed">
      <tbody>
        <tr>
          <td>Test duration</td>
          <td><span id="testDuration">0</span> sec</td>
        </tr>
        <tr>
          <td>Scenarios created</td>
          <td><span id="scenariosCreated">0</span></td>
        </tr>

        <tr>
          <td>Scenarios completed</td>
          <td><span id="scenariosCompleted">0</span></td>
        </tr>
      </tbody>
    </table>
  </div>

  <div class="col-lg-5" id="scenarioCountsContainer">
    <div>
      <strong>Scenario counts:</strong>

      <p></p>

      <table class="table table-bordered table-hover table-condensed" id="scenarioCounts">
      </table>
    </div>
  </div>

  <div class="col-lg-1">
    <div id="codesContainer">
      <strong>Codes</strong>

      <p></p>

      <table class="table table-bordered table-hover table-condensed" id="codes">
      </table>
    </div>
  </div>

  <div class="col-lg-3">
    <div id="errorsContainer">
      <strong>Errors</strong>

      <p></p>

      <table class="table table-bordered table-hover table-condensed" id="errors">
      </table>
    </div>
  </div>
</div> <!-- /.row -->

<div class="row">
  <div class="text-center col-lg-12">
    <h2>Charts</h2>
  </div>
</div>

<div class="row">
  <div class="latency-histogram text-center col-lg-12"></div>
</div>

<div class="row">
  <div class="latency text-center col-lg-12"></div>
</div>

<div class="latency-legend"></div>

<div class="row">

</div>

<div class="row">
  <div class="concurrency text-center col-lg-12"></div>
</div>

<div class="row">
  <div class="rps-mean text-center col-lg-12"></div>
</div>
<div class="row">
  <div class="rps-count text-center col-lg-12"></div>
</div>

<div class="row">
  <div class="codes-line text-center col-lg-12"></div>
</div>
<div class="row">
  <div class="errors-line text-center col-lg-12"></div>
</div>


  


</div>

<div class="row">
  <div class="col-lg-8 col-lg-offset-2">
    <h3 class="text-center">Raw report data</h3>
    <p>This is the raw JSON stats output that the report was generated from.</p>
    <div id="editor">
    </div>
  </div>
</div>

<script>
var editor = ace.edit("editor");
editor.getSession().setMode("ace/mode/javascript");
editor.setValue(JSON.stringify(Report, null, 2));
editor.gotoLine(1);editor.setHighlightActiveLine(false);

var l = _;

$('#timestamp').html(moment(Report.aggregate.timestamp).format('DD MMM YYYY HH:mm:SS'));
$('#testDuration').html(l.size(Report.intermediate) * 10);
$('#scenariosCompleted').html(Report.aggregate.scenariosCompleted);
$('#scenariosCreated').html(Report.aggregate.scenariosCreated);

var markers = [];
if(l.size(Report.phases) > 0) {
  markers = l.foldl(Report.phases, function(acc, phase, index) {
    var label = phase.name || 'Phase ' + (index + 1);
    var timestamp = (index === 0) ? 0 : Report.phases[index - 1].duration + acc[index - 1].timestamp;

    acc.push({
      timestamp: timestamp,
      label: label
    });

    return acc;
  }, []);
}

if (l.size(Report.aggregate.scenarioCounts) > 0) {
  l.each(Report.aggregate.scenarioCounts, function(count, name) {
    var $tdName = $('<td>' + name + '</td>');
    var percentage = Math.round(count / Report.aggregate.scenariosCreated * 100 * 1000) / 1000;
    var $tdCount = $('<td>' + count + ' (' + percentage + '%)' + '</td>');
    var $el = $('<tr></tr>')
      .append($tdName)
      .append($tdCount)
      .appendTo($('#scenarioCounts'));
  });
} else {
  $('#scenarioCountsContainer').hide();
}

if (l.size(Report.aggregate.codes) > 0) {
  l.each(Report.aggregate.codes, function(count, code) {
    var anchor = '';
    if (code >= 100 && code < 200) {
      anchor = '#1xx_Informational';
    } else if (code >= 200 && code < 300) {
      anchor = '#2xx_Success';
    } else if (code >= 300 && code < 400) {
      anchor = '#3xx_Redirection';
    } else if (code >= 400 && code < 500) {
      anchor = '#4xx_Client_Error';
    } else if (code >= 500 && code < 600) {
      anchor = '#5xx_Server_Error';
    }

    var $a = $('<a>' + code + '</a>').attr('href', 'https://en.wikipedia.org/wiki/List_of_HTTP_status_codes' + anchor);
    var $td = $('<td></td>').append($a);
    var $el = $('<tr></tr>')
      .append($td)
      .append($('<td>' + count + '</td>'))
      .appendTo($('#codes'));
  });
} else {
  $('#codesContainer').hide();
}

if (l.size(Report.aggregate.errors) > 0) {
  l.each(Report.aggregate.errors, function(count, code) {
    var $el = $('<tr></tr>')
      .append($('<td>' + code + '</td>'))
      .append($('<td>' + count + '</td>'))
      .appendTo($('#errors'));
  });
} else {
  $('#errorsContainer > p').html('&#10004; Test completed without network or OS errors.');
}

var histogramData = l.map(Report.aggregate.latency, function(v, k) { return {bin: k, value: v} });

MG.data_graphic({
  chart_type: 'bar',
  x_label: 'Percentile',
  y_label: '(ms)',
  animate_on_load: true,
  title: 'Overall Latency Distribution',
  description: 'Distribution of all observed response latencies',
  target: '.latency-histogram',
  data: histogramData,
  x_accessor: 'bin',
  y_accessor: 'value',
  binned: true,
  height: 250,
  interpolate: 'monotone',
  padding_percentage: 0,
  bar_orientation: 'vertical',
  width: 450
});

var chartData = l.map(
  window.Report.intermediate,
  function(o,i) {
    return {
      timestamp: i*10+10,

      rpsMean: o.rps.mean,
      rpsCount: o.rps.count,
      concurrency: o.concurrency,
      latencyMax: o.latency.max,
      latencyp99: o.latency.p99,
      latencyp95: o.latency.p95,
      latencyMedian: o.latency.median,
      latencyMin: o.latency.min
    }
  });

//
// Response codes
//

if (l.size(Report.aggregate.codes) > 0) {
  var codesData = l.foldl(Report.intermediate, function(acc, o, i) {
    var res = {};
    res.timestamp = i*10+10;
    l.each(o.codes, function(count, code) {
      res[code] = count;
    });
    acc.push(res);
    return acc;
  }, []);
  var uniqueCodes = l.foldl(Report.intermediate, function(acc, o) {
    l.each(o.codes, function(count, code) {
      if (l.indexOf(acc, code) === -1) {
        acc.push(code);
      }
    });
    return acc;
  }, []);

  MG.data_graphic({
    x_label: 'Time',
    y_label: 'Count',
    title: 'HTTP codes',
    description: 'Occurence of HTTP response codes',
    target: '.codes-line',
    data: codesData,
    x_accessor: 'timestamp',
    y_accessor: uniqueCodes,
    legend: uniqueCodes,
    right: 50,
    chart_type: 'line',
    area: false,
    markers: markers,
    width: 900
  });
}

//
// Errors
//

if (l.size(Report.aggregate.errors) > 0) {
  var errorData = l.foldl(Report.intermediate, function(acc, o, i) {
    var res = {};
    res.timestamp = i*10+10;
    l.each(o.errors, function(count, name) {
      res[name] = count;
    });
    acc.push(res);
    return acc;
  }, []);
  var uniqueErrors = l.foldl(Report.intermediate, function(acc, o) {
    l.each(o.errors, function(count, name) {
      if (l.indexOf(acc, name) === -1) {
        acc.push(name);
      }
    });
    return acc;
  }, []);

  MG.data_graphic({
    title: 'Error Codes',
    description: 'Occurence of error codes',
    target: '.errors-line',
    data: errorData,
    x_accessor: 'timestamp',
    y_accessor: uniqueErrors,
    chart_type: 'line',
    area: false,
    markers: markers
  });

}

//
// Latency
//
MG.data_graphic({
  chart_type: 'line',
  x_label: 'Time',
  y_label: '(ms)',
  animate_on_load: true,
  area: false,
  title: "Latency At Intervals",
  description: "Latency values at different points during the test run",
  data: chartData,
  target: '.latency',
  width: 900,
  x_accessor: 'timestamp',
  y_accessor: ['latencyMin', 'latencyMedian', 'latencyp95', 'latencyMax'],
  legend: ['min', 'p50', 'p95', 'max'],
  //legend_target: '.latency-legend',
  right: 50,
  interpolate: 'monotone',
  mouseover: function(d, i) {
  },
  markers: markers
        });

            MG.data_graphic({
            animate_on_load: true,
            area: false,
            y_label: 'Count',
            x_label: 'Time',
            title: 'Concurrent users',
            description: 'Concurrent users',
            data: chartData,
            target: '.concurrency',
            x_accessor: 'timestamp',
            y_accessor: ['concurrency'],
            interpolate: 'monotone',
            markers: markers,
            width: 900
            });

MG.data_graphic({
  animate_on_load: true,
  area: false,
  y_label: 'Count',
  x_label: 'Time',
  title: 'Mean RPS',
  description: 'Mean requests per second',
  data: chartData,
  target: '.rps-mean',
  x_accessor: 'timestamp',
  y_accessor: ['rpsMean'],
  interpolate: 'monotone',
  markers: markers,
  width: 900
});

MG.data_graphic({
  animate_on_load: true,
  area: false,
  y_label: 'Count',
  x_label: 'Time',
  title: 'RPS Count',
  description: 'Count of requests per second',
  data: chartData,
  target: '.rps-count',
  x_accessor: 'timestamp',
  y_accessor: ['rpsCount'],
  interpolate: 'monotone',
  markers: markers,
  width: 900
});
</script>
<div id="footer">
  <footer>This report was created with <a href="https://artillery.io">Artillery</a> - free open-source load-testing for HTTP and WebSockets</footer>
</div>
</body>
</html>
